unit uAcessorios;

interface

uses
  Dialogs, IniFiles, ZipMstr, Classes, SysUtils, uDefEstatR, uDllCall,
  uConexaoR, Forms;

type

  TTipoPlugIn = (tpg_R, tpg_dll);


  TPlugIn = class
    FileName : String;
    FilePath : String;
  end;


  TPlugIns = class
  private
    FCodigoFilePath : Integer;
    FPlugIns:TList;
  public
    constructor Create;
    procedure Add(pPlugIn:TPlugIn);
    function GetNextPathName:String;
    destructor Destroy;
  end;


  TLink = Class
    Tag        : Integer;
    MainFile   : String;
    Nome       : String;
    Icone      : Integer;
    HintFile   : String;
    PlugInName : String;
    Tipo       : TTipoPlugIn;
    IdDll      : Integer;
    TempDir    : String;
    FrmClass   : TFormClass;
    constructor Create;
    procedure Executa;
    destructor Destroy;
  end;


  TSecao = class
  private
    FLinks : TList;
  public
    Nome : String;
    constructor Create;
    procedure AddLink(pLink:TLink);
    function GetLink(pIdx:Integer; var pLink:TLink):Boolean;
    destructor Destroy;
  end;


  TSecoes = class
  private
    FSecoes : TList;
  public
    constructor Create;
    procedure Add(pSecao:TSecao);
    function GetSecao(pIdx:Integer;var pSecao:TSecao):Boolean;
    function GetSecaoFromName(pNome:String):TSecao;
    destructor Destroy;
  end;


  TAtalhos = Class
  private
  public
    Secoes : TSecoes;
    constructor Create;
    procedure Carrega;
    destructor Destroy;
  end;


var
  PlugIns : TPlugIns;
  vDllPlug : TDllHandler;
  vAtalhos  : TAtalhos;


implementation

var
  vTagLink : Integer;


constructor TPlugIns.Create;
begin
  FPlugIns := TList.Create;
end;


procedure TPlugIns.Add(pPlugIn:TPlugIn);
begin
  Inc(FCodigoFilePath);
  pPlugIn.FilePath := IntToStr(FCodigoFilePath)+'\';
  FPlugIns.Add(pPlugIn);
end;


function TPlugIns.GetNextPathName:String;
begin
  Result := IntToStr(FCodigoFilePath);
end;


destructor TPlugIns.Destroy;
begin
  while FPlugIns.Count>0 do
    FPlugIns.Delete(0);

  inherited;
end;


{
procedure ExtractPlugIn(pArquivo:String);
var
  FZip : TZipMaster;
begin
  FZip := TZipMaster.Create(Nil);
  try
    FZip.ZipFileName := cs_DirPlugIns+pArquivo;
    FZip.ExtrBaseDir := cs_DirPlugInsTmp;
    FZip.ExtrOptions := [ExtrOverWrite];
    FZip.Extract;
  finally
    FZip.Free;
  end;
end;
}

//******************************************************************************
constructor TLink.Create;
begin
  // Hint := TStringList.Create;
end;


procedure TLink.Executa;
var
  vFrm : TForm;
begin
  if FrmClass <> Nil then
  begin
    vFrm := FrmClass.Create(Application);
    vFrm.ShowModal;
  end
  else
  begin
    if Tipo = tpg_R then
    begin
      ConexaoR.RCon.WorkingDirectory := TempDir;
      ConexaoR.RCon.Source(MainFile);
    end
    else
    begin
      vDllPlug.Nome := TempDir + MainFile;
      vDllPlug.Load;
      vDllPlug.Send_RConnection;

      vDllPlug.Executa(IdDll);
    end;
  end;
end;


destructor TLink.Destroy;
begin
  // Hint.Free;
end;


//******************************************************************************
constructor TSecao.Create;
begin
  FLinks := TList.Create;
end;


procedure TSecao.AddLink(pLink:TLink);
begin
  Inc(vTagLink);
  pLink.Tag := vTagLink;
  FLinks.Add(pLink);
end;


function TSecao.GetLink(pIdx:Integer; var pLink:TLink):Boolean;
begin
  if pIdx < FLinks.Count then
  begin
    Result := True;
    pLink := TLink(FLinks[pIdx]);
  end
  else
  begin
    Result := False;
    pLink := Nil;
  end;
end;



destructor TSecao.Destroy;
begin
  FLinks.Free;
end;


//******************************************************************************
constructor TSecoes.Create;
begin
  FSecoes := TList.Create;
end;


function TSecoes.GetSecao(pIdx:Integer;var pSecao:TSecao):Boolean;
begin
  if pIdx < FSecoes.Count then
  begin
    Result := True;
    pSecao := TSecao(FSecoes[pIdx]);
  end
  else
  begin
    Result := False;
    pSecao := Nil;
  end;
end;


function TSecoes.GetSecaoFromName(pNome:String):TSecao;
var
  vIdx : Integer;
  vSecao : TSecao;
begin
  vIdx := 0;
  Result := Nil;
  while (GetSecao(vIdx, vSecao)) and (Result=Nil) do
  begin
    if (UpperCase(vSecao.Nome) = upperCase(pNome)) then
      Result := vSecao;
    Inc(vIdx);
  end;
end;


procedure TSecoes.Add(pSecao:TSecao);
begin
  FSecoes.Add(pSecao);
end;


destructor TSecoes.Destroy;
begin
  FSecoes.Free;
end;


//******************************************************************************
constructor TAtalhos.Create;
begin
  Secoes := TSecoes.Create;
  vTagLink := 0;
end;


destructor TAtalhos.Destroy;
begin
  Secoes.Free;
end;


procedure TAtalhos.Carrega;
var
  vArq      : TIniFile;
  FZip      : TZipMaster;


  procedure Carrega_Link(pStr:String;pLink:TLink);
  var
    vPos : Integer;
  begin
    vPos := Pos('=',pStr);
    pLink.Nome := Copy(pStr,1,vPos-1);
    pLink.MainFile := Copy(pStr,vPos+1,200);
  end;

  (*
  procedure Carrega_Atalhos_Secao(pSecao:TSecao);
  var
    vIdx   : Integer;
    vLink  : TLink;
    vValores : TStringList;
  begin
    vValores := TStringList.Create;
    try
      vArq.ReadSectionValues(pSecao.Nome,vValores);
      for vIdx := 0 To vValores.Count-1 do
      begin
        vLink := TLink.Create;
        Carrega_link(vValores.strings[vIdx], vLink);
        pSecao.AddLink(vLink);
      end;
    finally
      vValores.Free;
    end;
  end;
  *)

  procedure Carrega_Arquivos(pLstArquivos:TStringList);
  var
    sr: TSearchRec;
  begin
    FillChar(sr,SizeOf(sr),0);
    if FindFirst(cs_DirPlugIns+'*.zip', faAnyFile	, sr) = 0 then
    begin
      repeat
        pLstArquivos.Add(sr.Name);
      until FindNext(sr) <> 0;
      FindClose(sr);
    end;
    pLstArquivos.Sort;
  end;


  procedure Abrir_Arquivo(pArquivo:String);
  var
    vArq : TStringList;
    vIdx : Integer;
    vExtensao : String;
  begin
    if FileExists(pArquivo) then
    begin
      (*
      vArq := TStringList.Create;
      try
        vArq.LoadFromFile(pArquivo);
        vExtensao := UpperCase(ExtractFileExt(pArquivo));
        if (vExtensao<>'.HTML') and (vExtensao<>'.HTM') then
        begin
          vArq.Text := '<body><font style="font-size: 8pt" face="Verdana"><p>' +
                       vArq.Text +
                       '</p></font>' +
                       '</body>';
          for vIdx := 0 To vArq.Count-1 do
          begin
            vArq.Strings[vIdx] := vArq.Strings[vIdx] + '</br>';
          end;
        end;
        vArq.SaveToFile(pArquivo);
      finally
        vArq.Free;
      end;*)
      // Result := vArq.Text;
    end;
  end;


  procedure Carrega_Links_Dll(pSecao:TSecao; pDll:string; pTmpDir:String);
  var
    vDllHandler : TDllHandler;
    vIdx : Integer;
    vTem : Boolean;

    vLink : TLink;
    vFrmName,
    vNome,
    vHint,
    vPlugInName : String;
  begin
    vDllHandler := TDllHandler.Create;
    try
      vDllHandler.Nome := pTmpDir+pDll;
      vDllHandler.Load;

      vIdx := 0;
      repeat
        vTem := vDllHandler.GetLink(vIdx,
                                    vNome,
                                    vHint);

        if vTem then
        begin
          vLink := TLink.Create;
          vLink.Nome := vNome;
          vLink.MainFile := pDll;
          vLink.HintFile := vHint;
          vLink.PlugInName := vPlugInName;
          vLink.IdDll := vIdx;
          vLink.Tipo := tpg_dll;
          vLink.TempDir := pTmpDir;
          Abrir_Arquivo(vLink.TempDir+vLink.HintFile);
          pSecao.AddLink(vLink);
        end;

        Inc(vIdx);
      until not vTem;
    finally
      vDllHandler.Free;
    end;
  end;


  procedure Carrega_Plugin(pArquivo:TFileName);
  var
    vIndice    : TIniFile;
    vStrSecao  : String;
    vSecao     : TSecao;
    vStrAux    : String;
    vLink      : TLink;

    vArquivo   : String;
    vPlugIn : TPlugIn;
    vDirTmp : String;
  begin
    try
      vPlugIn := TPlugIn.Create;
      vPlugIn.FileName := pArquivo;
      PlugIns.Add(vPlugIn);

      vDirTmp := cs_DirPlugInsTmp+vPlugIn.FilePath;
      FZip.ZipFileName := cs_DirPlugIns+pArquivo;
      FZip.ExtrBaseDir := vDirTmp;
      FZip.ExtrOptions := [ExtrOverWrite];

      CreateDir(vDirTmp);
      FZip.Extract;

      vIndice := TIniFile.Create(FZip.ExtrBaseDir+'\index');
      try
        vStrSecao := vIndice.ReadString('index','page','');
        if vStrSecao='' then
          raise Exception.Create('Seo [index] no encontrada');

        vSecao := Secoes.GetSecaoFromName(vStrSecao);
        if vSecao = Nil then
        begin
          vSecao := TSecao.Create;
          vSecao.Nome := vStrSecao;
          Secoes.Add(vSecao);
        end;

        vArquivo := vIndice.ReadString('index','main','');
        if UpperCase(ExtractFileExt(vArquivo))='.R' then
        begin
          vLink := TLink.Create;
          vLink.Nome := vIndice.ReadString('index','name','noname');
          vLink.MainFile := vIndice.ReadString('index','main','');
          vLink.HintFile := vIndice.ReadString('index','hint','');
          vLink.PlugInName := pArquivo;
          vLink.Tipo := tpg_R;
          vLink.TempDir := vDirTmp;
          Abrir_Arquivo(vDirTmp+vLink.HintFile);
          vSecao.AddLink(vLink);
        end
        else
        begin
          Carrega_Links_Dll(vSecao, vArquivo, vDirTmp);
        end;

      finally
        vIndice.Free;
      end;
    except
      On E:Exception do 
        ShowMessage('No foi possvel carregar plugin "' + pArquivo + '": ' +  E.Message );
    end;
  end;


var
  vSections : TStringList;
  vItens    : TStringList;
  vSecao    : TSecao;
  vItem     : Integer;

  vArquivos : TStringList;
begin
  CreateDir(cs_DirWorkspace);
  CreateDir(cs_DirPlugInsTmp);

  vArquivos := TStringList.Create;
  try
    FZip := TZipMaster.Create(Nil);
    try
      Carrega_Arquivos(vArquivos);
      for vItem:=0 to vArquivos.Count-1 do
      begin
        Carrega_Plugin(vArquivos[vItem]);
      end;
    finally
      FZip.Free;
    end;
  finally
    vArquivos.Free;
  end;
end;


initialization
PlugIns := TPlugIns.Create;
vDllPlug := TDllHandler.Create;
vAtalhos := TAtalhos.Create;


finalization
PlugIns.Free;
vDllPlug.Free;
vAtalhos.Free;

end.



