unit uDefEstatR;

interface

uses
  Forms, SysUtils, RCom, STATCONNECTORSRVLib_TLB, IniFiles; 

  function DefFilePathR(pArquivo:String):String;

type
  TDados_Grafico_Estimacao = record
    VlrInicial : Double;
    VlrFinal   : Double;
    Intervalo  : Double;
    Avancado   : String;
  end;

  TCfg_Ambiente = Class(TIniFile)
    Dados_Grafico_Estimacao : TDados_Grafico_Estimacao;
    procedure Atualiza_Do_Arquivo;
    procedure Atualiza_Para_Arquivo;
    procedure Salvar;
  private
  end;


var
  Cfg_Ambiente   : TCfg_Ambiente;
  PathExecutavel : String;

  cs_DirPlugIns    : String;
  cs_DirPlugInsTmp : String;
  cs_DirWorkspace  : String;


implementation




function DefFilePathR(pArquivo:String):String;
var
  vIdx : Integer;
begin
  Result := '';

  for vIdx := 1 to Length(pArquivo) do
  begin
    if Copy(pArquivo,vIdx,1)='\' then
      Result := Result + '\';
    Result := Result + Copy(pArquivo,vIdx,1);
  end;
end;


procedure TCfg_Ambiente.Atualiza_Do_Arquivo;
var
  vStrSecao : String;
begin
  vStrSecao := 'CFG_Estimacao_Parametros';
  Dados_Grafico_Estimacao.VlrInicial := ReadFloat(vStrSecao, 'VlrInicial', -3);
  Dados_Grafico_Estimacao.VlrFinal   := ReadFloat(vStrSecao, 'VlrFinal', 3);
  Dados_Grafico_Estimacao.Intervalo  := ReadFloat(vStrSecao, 'Intervalo', 0.5);
  Dados_Grafico_Estimacao.Avancado   := ReadString(vStrSecao, 'Avancado', '');
end;


procedure TCfg_Ambiente.Salvar;
var
  vStrSecao : String;
begin
  vStrSecao := 'CFG_Estimacao_Parametros';
  WriteFloat(vStrSecao, 'VlrInicial', Dados_Grafico_Estimacao.VlrInicial);
  WriteFloat(vStrSecao, 'VlrFinal',   Dados_Grafico_Estimacao.VlrFinal);  
  WriteFloat(vStrSecao, 'Intervalo',  Dados_Grafico_Estimacao.Intervalo);
  WriteString(vStrSecao, 'Avancado',   Dados_Grafico_Estimacao.Avancado );
  UpdateFile;
end;


procedure TCfg_Ambiente.Atualiza_Para_Arquivo;
begin
end;


initialization
  DecimalSeparator := '.';
  PathExecutavel   := ExtractFilePath(Application.ExeName);

  cs_DirPlugIns    := PathExecutavel+'plugins\';
  cs_DirPlugInsTmp := cs_DirPlugIns + 'Temp\';
  cs_DirWorkspace  := PathExecutavel+'workspace\';

  Cfg_Ambiente     := TCfg_Ambiente.Create( ExtractFilePath(Application.ExeName)+'tri.ini' );
  Cfg_Ambiente.Atualiza_Do_Arquivo;

end.
