unit uDllCall;

interface

uses
  Windows, SysUtils, Dialogs, uDefEstatR, RCom, uConexaoR;

type
  TDll_GetLink = procedure(pNrAtalhopItem:Integer;
                          var pNomeAtalho:pChar;
                          var pDocumentacao:pchar;
                          var pAchou:Boolean);

  TDll_Send_RConnection = procedure(pRCon:TRConnector);

  TDll_Get_Workspace = procedure(pDiretorio:PChar);

  TDll_Executa = procedure(pLink:Integer);

  TDllHandler = class
  private
    FLoaded : Boolean;
    FHandle : THandle;
    FNome : String;
    procedure Seta_Nome(pNome:String);
  public
    function GetLink(var pNrAtalho:Integer;
                     var pNomeAtalho:String;
                     var pDocumentacao:String):Boolean;
    procedure Executa(pRotina:Integer);
    procedure Load;
    procedure Send_RConnection;
    procedure Get_Workspace;
  published
    property Nome : String read FNome write Seta_Nome;
  end;


implementation


procedure TdllHandler.Load;
begin
  FHandle := LoadLibrary(PChar(Nome));

  if FHandle = 0 then
    raise Exception.Create('No foi possvel carregar plug-in');

  FLoaded := True;

  Get_Workspace;
end;


procedure TDllHandler.Get_Workspace;
var
  vProc : TDll_Get_Workspace;
begin
  // Envia o diretrio de trabalho
  @vProc := GetProcAddress(FHandle, 'Get_Workspace');
  if @vProc <> Nil then
  begin
    vProc(PChar(cs_DirWorkspace));
  end;
end;


procedure TDllHandler.Send_RConnection;
var
  vProc : TDll_Send_RConnection;
begin
{  @vProc := GetProcAddress(FHandle, 'Send_RConnection');
  if @vProc <> Nil then
  begin
    vProc(ConexaoR.RCon);
  end;}
end;


procedure TDllHandler.Seta_Nome(pNome:String);
begin
  if pNome <> FNome then
  begin
    FLoaded := False;
    FNome := pNome;
  end; // Seno j carregou...
end;


function TdllHandler.GetLink(var pNrAtalho:Integer;
                     var pNomeAtalho:String;
                     var pDocumentacao:String):Boolean;
var
  vProc : TDll_GetLink;
  vFormName : PChar;
  vNome : PChar;
  vPlugInName: PChar;
  vHint : pChar;
begin
  Result := False;

  @vProc := GetProcAddress(FHandle, 'GetLink');
  if @vProc <> Nil then
  begin
    try
      vProc(pNrAtalho, vNome, vHint, Result);
    except
      Result := False;
      MessageDlg('Erro ao acessar ' + Nome, mtError, [mbOk],0);
    end;
    // pFormName := StrPas(vFormName);
    pNomeAtalho := StrPas(vNome);
    pDocumentacao := StrPas(vHint);
    // pPlugInName := StrPas(vPlugInName);
  end;
end;


procedure TdllHandler.Executa(pRotina:Integer);
var
  vProc : TDll_Executa;
begin
  @vProc := GetProcAddress(FHandle, 'Executa');
  if @vProc = Nil then
    raise Exception.Create('No encontrado procedimento "Executa()"');

  vProc(pRotina);
end;

end.
