unit uFrmDatasets;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uFrmPadrao, ComCtrls, StdCtrls, Buttons, uFrmImportarArquivo,
  uDataSet, uFrmSelecaoMetodo, uMetodos, uDefEstatR, ExtCtrls,
  uFrmSelFuncao, uFuncao, ToolWin, ImgList, uFrmEqualizacao, uEqualizacao,
  DB, Grids, DBGrids, DBClient;

const
  csItens = 'Itens';
  csIndividuos = 'Indivduos'; 


type
  TFrmDataSets = class(TFrmPadrao)
    tvDatasets: TTreeView;
    PageControl2: TPageControl;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    MemoDataset: TMemo;
    ImageList1: TImageList;
    Panel3: TPanel;
    Label2: TLabel;
    CBMetodos: TComboBox;
    BtnCalcTracoLatente: TButton;
    BtnCalcularParametrosItens: TButton;
    BtnOutrasFuncoes: TButton;
    Button1: TButton;
    Button2: TButton;
    BtnEqualizacao: TButton;
    cdsIndividuos: TClientDataSet;
    dsIndividuos: TDataSource;
    notebook: TNotebook;
    DBGridIndividuos: TDBGrid;
    DBGridItems: TDBGrid;
    cdsItems: TClientDataSet;
    dsItems: TDataSource;
    procedure tvDatasetsChange(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BtnCalcTracoLatenteClick(Sender: TObject);
    procedure BtnCalcularParametrosItensClick(Sender: TObject);
    procedure BtnOutrasFuncoesClick(Sender: TObject);
    procedure BtnEqualizacaoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    vFrmSelFuncao : TFrmSelFuncao;
    FLastDataSet  : TTriDataset;

    procedure Carregar_Datasets;
    function GetSelectedDataSet:TTRIDataSet;
    procedure AoSelecionarFuncao(pFuncao:TFuncao);
    function GetSelectedMethod:TMetodo;

    procedure IncluirDataset;
    procedure CalcularTracoLatente;
    procedure CalcularParametrosItens;
    procedure CalcularOutrasFuncoes;
  end;

var
  FrmDataSets: TFrmDataSets;

implementation

{$R *.dfm}


procedure TFrmDataSets.tvDatasetsChange(Sender: TObject; Node: TTreeNode);


  procedure CarregaParametrosItens(pDataSet:TTriDataset);
  var
    vLin : Integer;
    vCol : Integer;
    vField : TFloatField;

    vTemPar : Boolean; // Tem parmetros calculados?
  begin
    vTemPar := High(pDataset.Itens) >= 0;

    if cdsItems.Active then
      cdsItems.EmptyDataSet;

    cdsItems.Close;
    cdsItems.FieldDefs.Clear;

    if High(pDataset.IDItems) > 0 then
    begin
      cdsItems.FieldDefs.Add('Seq.',ftInteger);
      cdsItems.FieldDefs.Add('Identificao',ftString,30);

      if vTemPar then // Parmetros de itens calculados?
      begin
        for vCol := 0 to High(pDataSet.Itens[0]) do
          // cdsItems.FieldDefs.Add('par' + IntToStr(vcol+1),ftFloat);
          cdsItems.FieldDefs.Add( pDataset.Metodo.ParamItems.GetParam(vCol+1).Name, ftFloat );
      end;

      cdsItems.CreateDataSet;

      // necessrio setar formato para campos numricos
      if vTemPar then
      begin
        for vCol := 2 to High(pDataSet.Itens[0])+2 do
        begin
          vField := TFloatField(cdsItems.Fields[vCol]);
          vField.DisplayFormat := '##0.0000';
        end;
      end;

      for vlin := 0 to High(pDataset.IDItems) do
      begin
        cdsItems.Append;
        cdsItems.FieldByName('Seq.').Value := vlin+1;
        cdsItems.FieldByName('Identificao').Value := pDataset.IDItems[vLin];

        if  vTemPar then
        begin
          for vCol := 0 to High(pDataSet.Itens[0]) do
            cdsItems.FieldByName( pDataset.Metodo.ParamItems.GetParam(vCol+1).Name ).Value := pDataSet.Itens[vLin,vCol];
        end;

        cdsItems.Post;
      end;

      cdsItems.First;
    end;
  end;


  procedure CarregaIndividuos(pDataset:TTRiDataSet);
  var
    vLin : Integer;
    vTemHab : Boolean;
  begin
    vTemHab := High(pDataset.Habilidades)>=0;

    if cdsIndividuos.Active then
      cdsIndividuos.EmptyDataSet;

    cdsIndividuos.Close;
    cdsIndividuos.FieldDefs.Clear;

    if High(pDataSet.IDIndividuos) >= 0 then
    begin
      cdsIndividuos.FieldDefs.Add('Seq.', ftInteger);
      cdsIndividuos.FieldDefs.Add('Identificao', ftString, 50);
      if vTemHab then
        cdsIndividuos.FieldDefs.Add('Trao Latente', ftFloat);

      cdsIndividuos.CreateDataSet;
      if vTemHab then
        TFloatField(cdsIndividuos.FieldByName('Trao Latente')).DisplayFormat := '##0.0000';

      for vLin := 0 to High(pDataSet.IDIndividuos) do
      begin
        cdsIndividuos.Append;
        cdsIndividuos.FieldByName('Seq.').Value := vLin+1;
        cdsIndividuos.FieldByName('Identificao').Value := pDataset.IDIndividuos[vLin];
        if vTemHab then
          cdsIndividuos.FieldByName('Trao Latente').Value := pDataset.Habilidades[vLin];
        cdsIndividuos.Post;
      end;

      cdsIndividuos.First;
    end
    else
    begin
    end;
  end;


var
  vDataSet : TTRIDataSet;
begin
  inherited;

  if Node.Level = 0 then
    vDataSet := TRIDataSets.GetDataSetByName(Node.Text)
  else
    vDataSet := TRIDataSets.GetDataSetByName(Node.Parent.Text);

  if (vDataSet <> Nil) then
  begin
    if (FLastDataSet <> vDataset) then
    begin
      vDataset.Define_Estruturas_Globais_R;

      if Node.Level = 0 then
      begin
        vDataSet.SaveToDisk(PathExecutavel + 'arq.txt');
        MemoDataset.Lines.LoadFromFile(PathExecutavel + 'arq.txt');
      end
      else
      begin
        if Node.Text = csIndividuos then
        begin
          vDataSet.SaveHabilidadesToDisk(PathExecutavel + 'individuos.txt');
          MemoDataset.Lines.LoadFromFile(PathExecutavel + 'individuos.txt');
          CarregaIndividuos(vDataset);
        end
        else if Node.Text = csItens then
        begin
          vDataSet.SaveParametrosItensToDisk(PathExecutavel + 'itens.txt');
          MemoDataset.Lines.LoadFromFile(PathExecutavel + 'itens.txt');
          CarregaParametrosItens(vDataSet);
        end;
      end;
    end;

    if  Node.Level > 0 then
    begin
      if Node.Text = csIndividuos then
      begin
        notebook.PageIndex := 0; // notebook.ActivePage := 'PgIndividuos';
        notebook.PageIndex := 0;
      end
      else
      begin
        notebook.PageIndex := 1; // ActivePage := 'PgItems';
        notebook.PageIndex := 1;
      end;
    end;
  end;

  // FLastDataSet := vDataset;
end;


procedure TFrmDataSets.Carregar_Datasets;
var
  vIdx : Integer;
  vDataSet : TTRiDataSet;
  vTreeNode : TTreeNode;
  vTreeNodeChild : TTreeNode;
begin
  tvDatasets.Items.Clear;

  vIdx := 0;
  while TRIDataSets.GetDataSet(vIdx,vDataSet) do
  begin
    vTreeNode := tvDataSets.Items.Add(nil, vDataSet.Nome);
    tvDataSets.Items.AddChild(vTreeNode, csItens);
    tvDataSets.Items.AddChild(vTreeNode, csIndividuos);
    Inc(vIdx);
  end;

  tvDatasets.FullExpand;
end;


procedure TFrmDataSets.FormCreate(Sender: TObject);
var
  vIdx : Integer;
  vMetodo : TMetodo;
begin
  inherited;

  FLastDataSet := Nil;

  vIdx := 0;
  while vMetodos.GetMetodo(vIdx,vMetodo) do
  begin
    CBMetodos.Items.Add(vMetodo.Nome);
    Inc(vIdx);
  end;

  Carregar_Datasets;
end;


function TFrmDataSets.GetSelectedDataSet:TTriDataSet;
begin
  if tvDatasets.Selected = Nil then
    Result := Nil
  else
  begin
    if tvDatasets.Selected.Level = 0 then
      Result := TRIDataSets.GetDataSetByName(tvDatasets.Selected.Text)
    else
      Result := TRIDataSets.GetDataSetByName(tvDatasets.Selected.Parent.Text);
  end;
end;


procedure TFrmDataSets.AoSelecionarFuncao(pFuncao:TFuncao);
var
  vStrNrItem : String;
begin
  if pFuncao.Tipo = tf_Nenhum then
  begin
    GetSelectedDataSet.ExecutaFuncao(pFuncao, 0);
  end
  else if pFuncao.Tipo = tf_Individuo then
  begin
    vStrNrItem := InputBox('Informe o indivduo','Indivduo', '');
    if vStrNrItem <> '' then
    begin
      GetSelectedDataSet.ExecutaFuncao(pFuncao, StrToInt(vStrNrItem));
    end;
  end
  else
  begin
    // vStrNrItem := InputBox('Informe o item','Item', '');
    vStrNrItem := IntToStr(cdsItems.RecNo);
    if vStrNrItem <> '' then
    begin
      GetSelectedDataSet.ExecutaFuncao(pFuncao, StrToInt(vStrNrItem));
    end;
  end;
end;

procedure TFrmDataSets.IncluirDataset;
var
  vFrmImportar : TFrmImportarArquivo;
begin
  inherited;

  vFrmImportar := TFrmImportarArquivo.Create(Nil);
  try
    vFrmImportar.NomObj := 'teste' + IntToStr(TRiDataSets.Count+1);
    vFrmImportar.ShowModal;
    if vFrmImportar.Confirmou then
    begin
      TRIDataSets.Importar(vFrmImportar.NomObj, vFrmImportar.Arquivo, vFrmImportar.Parametros);
      Carregar_Datasets;
    end;
  finally
    vFrmImportar.Free;
  end;
end;


procedure TFrmDataSets.CalcularTracoLatente;
var
  FrmSelecaoMetodo : TFrmSelecaoMetodo;
  vDataSet : TTriDataSet;
begin
  inherited;

  if GetSelectedMethod = Nil then
    raise Exception.Create('Mtodo no foi selecionado');
  if GetSelectedDataset = nil then
    raise Exception.Create('Conjunto de dados no foi selecionado');

  FrmSelecaoMetodo := TFrmSelecaoMetodo.Create(Nil);
  try
    FrmSelecaoMetodo.MetodoSelecionado := GetSelectedMethod;
    FrmSelecaoMetodo.TipoPrograma := tp_Habilidades;
    FrmSelecaoMetodo.ShowModal;
    if FrmSelecaoMetodo.Confirmou then
    begin
      vDataSet := GetSelectedDataSet;
      if vDataSet <> Nil then
        vDataSet.Estimar_Habilidades(FrmSelecaoMetodo.MetodoSelecionado);
    end;
  finally
    FrmSelecaoMetodo.Free;
  end;
end;

procedure TFrmDataSets.CalcularParametrosItens;
var
  FrmSelecaoMetodo : TFrmSelecaoMetodo;
  vDataSet : TTriDataSet;
begin
  inherited;

  if GetSelectedMethod = Nil then
    raise Exception.Create('Mtodo no foi selecionado');
  if GetSelectedDataset = nil then
    raise Exception.Create('Conjunto de dados no foi selecionado');

  FrmSelecaoMetodo := TFrmSelecaoMetodo.Create(Nil);
  try
    FrmSelecaoMetodo.MetodoSelecionado := GetSelectedMethod;
    FrmSelecaoMetodo.TipoPrograma := tp_Parametros_Itens;
    FrmSelecaoMetodo.ShowModal;
    if FrmSelecaoMetodo.Confirmou then
    begin
      // vDataSet := TRIDataSets.GetDataSetByName(tvDatasets.Selected.Text);
      vDataSet := GetSelectedDataSet;
      if vDataSet <> Nil then
        vDataSet.Estimar_Parametros_Itens(GetSelectedMethod);
    end;
  finally
    FrmSelecaoMetodo.Free;
  end;
end;

procedure TFrmDataSets.CalcularOutrasFuncoes;
begin
  inherited;

  if GetSelectedMethod = Nil then
    raise Exception.Create('Mtodo no foi selecionado');
  if GetSelectedDataset = nil then
    raise Exception.Create('Conjunto de dados no foi selecionado');

  FreeAndNil(vFrmSelFuncao);

  vFrmSelFuncao := TFrmSelFuncao.Create(Self);
  vFrmSelFuncao.Funcoes := GetSelectedMethod.Funcoes;
  vFrmSelFuncao.AoSelecionarFuncao := AoSelecionarFuncao;
  vFrmSelFuncao.Show;
end;

procedure TFrmDataSets.Button1Click(Sender: TObject);
begin
  inherited;
  IncluirDataset;
end;

procedure TFrmDataSets.BtnCalcTracoLatenteClick(Sender: TObject);
begin
  inherited;
  CalcularTracoLatente;
end;

procedure TFrmDataSets.BtnCalcularParametrosItensClick(Sender: TObject);
begin
  inherited;
  CalcularParametrosItens;
end;

procedure TFrmDataSets.BtnOutrasFuncoesClick(Sender: TObject);
begin
  inherited;
  CalcularOutrasFuncoes;
end;

function TFrmDataSets.GetSelectedMethod: TMetodo;
begin
  Result := vMetodos.GetMetodoByName(CBMetodos.Text);
end;


procedure TFrmDataSets.BtnEqualizacaoClick(Sender: TObject);
var
  vFrmEqualizacao : TFrmEqualizacao;
  vDataset : TTriDataset;
  vEqualizacao : TEqualizacao;
begin
  inherited;
  //
  vFrmEqualizacao := TFrmEqualizacao.Create(Self);
  try
    vFrmEqualizacao.ShowModal;
    if vFrmEqualizacao.Confirmou then
    begin
      vEqualizacao := TEqualizacao.Create;
      try
        while vFrmEqualizacao.GetSelectedDataSet(vDataset) do
          vEqualizacao.Add(vDataset);
        vEqualizacao.Equalizar(GetSelectedMethod);
      finally
        vEqualizacao.Free;
      end;
    end;
  finally
    vFrmEqualizacao.Free;
  end;
end;

end.
