unit uFrmPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, ToolWin, uFrmPadrao, OleServer,
  RCom, STATCONNECTORSRVLib_TLB, StdCtrls, ImgList, uDefEstatR, Buttons, uImpParse,
  JvOutlookBar, JvExControls, JvComponent, JvNavigationPane, JvAppStorage,
  JvAppXMLStorage, JvFormPlacement, Menus, uAcessorios, JvgLabel,
  JvComponentBase, uConexaoR, uMetodos, XPMan;

type
  TFrmPrincipal = class(TForm)
    ToolBar1: TToolBar;
    Panel_Vazio: TPanel;
    ImageList1: TImageList;
    stsBar: TStatusBar;
    ToolButton3: TToolButton;
    odImportar: TOpenDialog;
    MenuLateral: TJvOutlookBar;
    JvAppXMLFileStorage1: TJvAppXMLFileStorage;
    JvFormStorage1: TJvFormStorage;
    mm1: TMainMenu;
    Arquivo1: TMenuItem;
    Sair1: TMenuItem;
    Opes1: TMenuItem;
    Configurar1: TMenuItem;
    Splitter1: TSplitter;
    pm: TPopupMenu;
    Executar1: TMenuItem;
    Editar2: TMenuItem;
    N1: TMenuItem;
    Excluir1: TMenuItem;
    XPManifest1: TXPManifest;
    procedure BtnConectarClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MenuLateralContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Editar2Click(Sender: TObject);
    procedure Executar1Click(Sender: TObject);
  private
    { Private declarations }
    vTlaAtual : TFrmPadrao;
  public
    vLinkAtu  : TLink;
    { Public declarations }
    procedure Mostra(pTela:TForm; pClasse:TFormClass);
    procedure Carrega_MenuLateral;
    procedure ClickBotaoMenu(Sender:TObject);
    function  GetLinkFromTag(pTag:Integer):TLink;
  end;

var
  FrmPrincipal: TFrmPrincipal;

implementation


{$R *.dfm}

uses
  uFrmDica, urmConfiguraPlugin;


function Busca_NrVersao:String;
var
  S: string;
  n, Len: DWORD;
  Buf: PChar;
  Value: PChar;
begin
  Result := '';

  S := Application.ExeName;
  n := GetFileVersionInfoSize(PChar(S), n);
  if n > 0 then
  begin
    Buf := AllocMem(n);
    GetFileVersionInfo(PChar(S), 0, n, Buf);

    if VerQueryValue(Buf, PChar('StringFileInfo\' +
                                IntToHex({GetSystemDefaultLangID}1046, 4) + '04E4\' +
                                'FileVersion'), Pointer(Value), Len) then
    begin
      Result := Value;
    end;

    FreeMem(Buf, n);
  end
end;

procedure TFrmPrincipal.Mostra(pTela:TForm; pClasse:TFormClass);
begin
  if vTlaAtual<>Nil then
  begin
    vTlaAtual.Fechar;
    FreeAndNil(vTlaAtual);
  end;

  if pClasse=Nil then
  begin
    Panel_Vazio.Visible := False;
  end
  else
  begin
    Panel_Vazio.Visible := True;
    if pTela = Nil then
      pTela := pClasse.Create(Self);

    pTela.Anchors := [];
    pTela.Align := alClient;
    pTela.BorderStyle := bsNone;
    pTela.WindowState := wsMaximized;
    pTela.Parent := Panel_Vazio;
    pTela.Show;
    TFrmPadrao(pTela).Mostrar;
    vTlaAtual := TFrmPadrao(pTela);
  end;
end;


procedure TFrmPrincipal.BtnConectarClick(Sender: TObject);
begin
  ConexaoR.RCon;
  stsBar.Panels[0].Text := 'Conectado com R';
  ConexaoR.RCon.WorkingDirectory := cs_DirPlugInsTmp;
end;


procedure TFrmPrincipal.Carrega_MenuLateral;
var
  vSecao    : TSecao;
  vIdx      : Integer;
  vPagina   : TJvOutlookBarPage;
  vIdxLinks : Integer;
  vBotao    : TJvOutlookBarButton;
  vLink     : TLink;
begin
  vAtalhos.Carrega;
  vIdx := 0;
  while vAtalhos.Secoes.GetSecao(vIdx,vSecao) do
  begin
    //vPagina := TJvOutlookBarPage.Create(Nil);
    vPagina := MenuLateral.Pages.Add;
    vPagina.Caption := vSecao.Nome;

    vIdxLinks := 0;
    while vSecao.GetLink(vIdxLinks, vLink) do
    begin
      vBotao := vPagina.Buttons.Add;
      vBotao.Caption := vLink.Nome;
      vBotao.Tag     := vLink.Tag;
      vBotao.OnClick := ClickBotaoMenu;
      Inc(vIdxLinks);
    end;

    Inc(vIdx);
  end;
end;


procedure TFrmPrincipal.FormCreate(Sender: TObject);
begin
  vMetodos.Carrega;
  Carrega_MenuLateral;
  Caption := 'TRI - [' + Busca_NrVersao + ']';  
end;


procedure TFrmPrincipal.ClickBotaoMenu(Sender:TObject);


  procedure Executa(pTag:Integer);
  var
    //vArquivo : String;
    vLink : TLink;

    vSecao : TSecao;
    vAchou : Boolean;

    vIdx   : Integer;
    vIdxLink : Integer;
  begin
    vIdx := 0;
    vAchou := False;
    while not vAchou and vAtalhos.Secoes.GetSecao(vIdx,vSecao) do
    begin
      vIdxLink := 0;
      while not vAchou and (vSecao.GetLink(vIdxLink,vLink)) do
      begin
        if vLink.Tag = pTag then
          vAchou := True
        else
          Inc(vIdxLink);
      end;
      Inc(vIdx);
    end;

    if vAchou then
    begin
      ConexaoR.RCon.Source(vLink.MainFile);
    end;
  end;


var
  FrmDicaPrograma : TFrmDica;
begin
  vLinkAtu := GetLinkFromTag( TJvOutlookBarButton(Sender).Tag );
  if vLinkAtu <> Nil then
  begin
    if (vLinkAtu.HintFile = '') and (vLinkAtu.FrmClass <> Nil) then
    begin
      Mostra(Nil,vLinkAtu.FrmClass);
      // vLinkAtu.FrmClass.Create(Nil);

      // Executa;
    end
    else
    begin
      FrmDicaPrograma := TFrmDica.Create(Application);
      FrmDicaPrograma.vLinkAtual := vLinkAtu;
      Mostra(FrmDicaPrograma,TFrmDica);
    end;
  end;
end;


procedure TFrmPrincipal.MenuLateralContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
var
  Button : TJvOutlookBarButton;
  //vLink  : TLink;
begin
  Button := MenuLateral.GetButtonAtPos(MousePos);
  if Button <> Nil then
  begin
    vLinkAtu := GetLinkFromTag(Button.Tag);
  end;
end;


function  TFrmPrincipal.GetLinkFromTag(pTag:Integer):TLink;
var
  //vArquivo : String;
  vLink : TLink;

  vSecao : TSecao;
  vAchou : Boolean;

  vIdx   : Integer;
  vIdxLink : Integer;
begin
  vIdx := 0;
  Result := nil;
  vAchou := False;
  while not vAchou and vAtalhos.Secoes.GetSecao(vIdx,vSecao) do
  begin
    vIdxLink := 0;
    while not vAchou and (vSecao.GetLink(vIdxLink,vLink)) do
    begin
      if vLink.Tag = pTag then
        vAchou := True
      else
        Inc(vIdxLink);
    end;
    Inc(vIdx);
  end;

  if vAchou then
    Result := vLink;
end;


procedure TFrmPrincipal.Editar2Click(Sender: TObject);
var
  vFrmConf : TFrmConfiguraPlugin;
begin
  vFrmConf := TFrmConfiguraPlugin.Create(Self);
  vFrmConf.vLink := vLinkAtu;
  vFrmConf.ShowModal;
  vFrmConf.Free;
  // ShowMessage(vLinkAtu.PlugInName);
end;

procedure TFrmPrincipal.Executar1Click(Sender: TObject);
begin
  vLinkAtu.Executa;
end;

end.
