unit uGeral;

interface

uses
  Classes, Forms, Controls, uFrmPadrao;

type
  TComposicao = class
  private
    FAutoDestruirItens : Boolean;
    FList : TList;
    FIdx : Integer;
    function Le_count:Integer;
  public
    constructor Create;
    destructor Destroy; override;
    procedure Delete(pIdx:Integer);
    procedure Clear;
    procedure First;
    procedure Next;
    function EOF:Boolean;
  protected
    procedure GetItem(pItem:Integer; var pResultado:Boolean; var pObj:TObject);
    procedure GetObject(var pObj:TObject);    
    procedure Add(pObjeto:TObject);
  published
    property AutoDestruirItens:Boolean read FAutoDestruirItens write FAutoDestruirItens;
    property Count:Integer read Le_Count;
  end;

  procedure Anexar_Form(pComponente:TComponent; pForm:TForm; pExibir:Boolean = True);


implementation


procedure Anexar_Form(pComponente:TComponent; pForm:TForm; pExibir:Boolean = True);
// Apresenta uma form sobre um componente.

// Obs: O parmetro pForm tem que ser TFrmPadrao para que seja chamado o mtodo virtual Show...
begin
  pForm.Anchors := [];
  pForm.Align := alClient;
  pForm.BorderStyle := bsNone;
  pForm.WindowState := wsMaximized;
  pForm.Parent := TWinControl(pComponente);
  pForm.Left := 0;
  pForm.Top := 0;
  // TWinControl(pComponente).Visible := True;
  if pExibir then
  begin
    if (pForm is TFrmPadrao) or (pForm.InheritsFrom(TFrmPadrao)) then
      TFrmPadrao(pForm).Show
    else
      pForm.Show;
  end;
end;

//******************************************************************************
constructor TComposicao.Create;
begin
  inherited Create;
  FList := TList.Create;
  AutoDestruirItens := True;
end;


function TComposicao.Le_count:Integer;
begin
  Result := FList.Count;
end;


procedure TComposicao.GetItem(pItem:Integer; var pResultado:Boolean; var pObj:TObject);
begin
  if pItem < FList.Count then
    pObj := FList.Items[pItem]
  else
    pObj := Nil;

  pResultado := pObj <> Nil;
end;


procedure TComposicao.Add(pObjeto:TObject);
begin
  FList.Add(pObjeto);
end;


procedure TComposicao.Delete(pIdx:Integer);
begin
  FList.Delete(pIdx);
end;


procedure TComposicao.Clear;
var
  vIdx : Integer;
begin
  for vIdx := 0 To FList.Count-1 do
    TObject(FList[vIdx]).Free;
  FList.Clear;
end;


function TComposicao.EOF: Boolean;
begin
  Result := FIdx >= FList.Count;
end;

procedure TComposicao.First;
begin
  FIdx := 0;
end;

procedure TComposicao.GetObject(var pObj:TObject);
var
  vResult : Boolean;
begin
  GetItem(FIdx, vResult, pObj);
  // pObj := FList.Items[FIdx];
end;

procedure TComposicao.Next;
begin
  Inc(FIdx);
end;

destructor TComposicao.Destroy;
begin
  if AutoDestruirItens then
    Clear;

  inherited;
end;


end.
