unit uMetodos;

interface

uses
  Forms, uGeral, uExArquivos, uDefTRI, Classes, SysUtils, XMLDoc, XMLIntf,
  ZipMstr, ActiveX, Dialogs, uProcessaTela, uFuncao;

type
  TTipoPrograma = (tp_Parametros_Itens, tp_Habilidades);


  TMetodo = class;


  TParamItem = class
    Name : String;
  end;


  TParamsItem = class(TComposicao)
    procedure Read(var pParam:TParamItem);
    function GetParam(pIdx:Integer):TParamItem; 
  end;


  TDadosMetodo = class
  public
    Metodo : TMetodo;

    Programa : String;
    Input : String;
    Modulo : TModulo;

    constructor Create(pOwner:TMetodo);
    procedure CarregaTela;
  end;


  TMetodo = class
    Nome : String;
    FileName : String;
    Parametros : TDadosMetodo;
    Habilidades : TDadosMetodo;
    Equalizacao : TDadosMetodo;

    Funcoes : TFuncoes;

    ParamItems : TParamsItem;

    constructor Create;
    function DirTemp : String;
    function BuscaDadosMetodo(pTipoPrograma:TTipoPrograma):TDadosMetodo;
    destructor Destroy;
    {procedure CarregaTelaParametros;
    procedure CarregaTela}
  end;


  TMetodos = class(TComposicao)
    function GetMetodo(pIdx:Integer; var pMetodo:TMetodo):Boolean;
    function GetMetodoByName(pNome:String):TMetodo;
    procedure Carrega;
  end;

var
  vMetodos : TMetodos;

implementation


{function TFuncao.Executa;
begin

end;


function TFuncoes.GetFuncao(pIdx:Integer; var pFuncao:TFuncao):Boolean;
begin
  inherited GetItem(pIdx, Result, TObject(pFuncao));
end;
}

//******************************************************************************
constructor TDadosMetodo.Create(pOwner:TMetodo);
begin
  inherited Create;
  Metodo := pOwner;
end;


procedure TDadosMetodo.CarregaTela;
begin
  if (Modulo = nil) and (Input <> '') then
  begin
    Modulo := TModulo.Create;
    Modulo.NomeArquivo := Metodo.DirTemp + Input;
    Modulo.Carrega_Elementos; 
  end;
end;


//******************************************************************************
function TMetodo.DirTemp : String;
begin
  Result := PathMetodos+'Temp\' + ChangeFileExt(FileName,'') + '\';
end;


function TMetodo.BuscaDadosMetodo(pTipoPrograma:TTipoPrograma):TDadosMetodo;
begin
  case pTipoPrograma of
   tp_Parametros_Itens:
      Result := Parametros;
   tp_Habilidades:
      Result := Habilidades;
  end;
end;


constructor TMetodo.Create;
begin
  Parametros := TDadosMetodo.Create(Self);
  Habilidades := TDadosMetodo.Create(Self);
  Equalizacao := TDadosMetodo.Create(Self);
  ParamItems := TParamsItem.Create;
  Funcoes := TFuncoes.Create;
end;


destructor TMetodo.Destroy;
begin
  Parametros.Free;
  Habilidades.Free;
  ParamItems.Free;
  Equalizacao.Free;
  Funcoes.Free;
end;


function TMetodos.GetMetodo(pIdx:Integer; var pMetodo:TMetodo):Boolean;
begin
  GetItem(pIdx, Result, TObject(pMetodo));
end;


function TMetodos.GetMetodoByName(pNome:String):TMetodo;
var
  vIdx : Integer;
  vMetodo : TMetodo;
begin
  vIdx := 0;
  Result := Nil;
  while (Result=Nil) and GetMetodo(vIdx, vMetodo) do
  begin
    if UpperCase(vMetodo.Nome) = UpperCase(pNome) then
      Result := vMetodo
    else
      Inc(vIdx);
  end;
end;


procedure TMetodos.Carrega;


  function Extrai_Dados_Metodo(pArquivo:TArquivo):TMetodo;
  var
    vDir : String;
    vTxtArquivo : TStringList;
    vNo : IXMLNode;
    vXML : TXMLDocument;
    vStream : TMemoryStream;
    FZip : TZipMaster;
    vNoAux : IXMLNode;

    vNomeNo : String;
    vFuncao : TFuncao;

    vParamItem : TParamItem;
  begin
    Result := TMetodo.Create;
    Result.FileName := pArquivo.Nome;
    CreateDir(Result.DirTemp);

    // Descompacta...
    FZip := TZipMaster.Create(Nil);
    try
      FZip.ZipFileName := PathMetodos + pArquivo.Nome;
      FZip.ExtrBaseDir := Result.DirTemp;
      FZip.ExtrOptions := [ExtrOverWrite];
      FZip.Extract;
    finally
      FZip.Free;
    end;

    // coInitialize(Nil);
    vXML := TXMLDocument.Create(Application);
    try
      vTxtArquivo := TStringList.Create;
      vTxtArquivo.LoadFromFile(Result.DirTemp + 'index.xml');
      vTxtArquivo.Text := '<?xml version="1.0" encoding="ISO-8859-1" ?>' +
                          vTxtArquivo.Text;

      vStream := TMemoryStream.Create;
      try
        vTxtArquivo.SaveToStream(vStream);
        vXML.LoadFromStream(vStream);
      finally
        vStream.Free;
      end;

      vNo := vXML.DocumentElement.ChildNodes.First;
      while vNo <> Nil do
      begin
        if UpperCase(vNo.NodeName)='NAME' then
          Result.Nome := vNo.Text
        else if UpperCase(vNo.NodeName)='PARAMETERS' then
        begin
          vNoAux := vNo.ChildNodes.First;
          while vNoAux <> Nil do
          begin
            vNomeNo := UpperCase(vNoAux.NodeName);

            if vNomeNo='PROGRAM' then
              Result.Parametros.Programa := vNoAux.Text
            else if vNomeNo='INPUT' then
              Result.Parametros.Input    := vNoAux.Text
            else if vNomeNo = 'OUTPUT' then
            begin
              vFuncao := TFuncao.Create;
              vFuncao.Tipo := tf_Itens;
              vFuncao.Nome := vNoAux.ChildNodes['name'].Text;
              vFuncao.Programa := vNoAux.ChildNodes['program'].Text;
              Result.Funcoes.Add(vFuncao);
            end
            else if vNomeNo = 'NAME' then
            begin
              vParamItem := TParamItem.Create;
              vParamItem.Name := vNoAux.Text;
              Result.ParamItems.Add(vParamItem);
            end;
            vNoAux := vNoAux.NextSibling;
          end;
        end
        else if UpperCase(vNo.NodeName)='ABILITIES' then
        begin
          vNoAux := vNo.ChildNodes.First;
          while vNoAux <> Nil do
          begin
            vNomeNo := UpperCase(vNoAux.NodeName);

            if vNomeNo='PROGRAM' then
              Result.Habilidades.Programa := vNoAux.Text
            else if vNomeNo='INPUT' then
              Result.Habilidades.Input    := vNoAux.Text
            else if vNomeNo = 'OUTPUT' then
            begin
              vFuncao := TFuncao.Create;
              vFuncao.Tipo := tf_Individuo;
              vFuncao.Nome := vNoAux.ChildNodes['name'].Text;
              vFuncao.Programa := vNoAux.ChildNodes['program'].Text;
              Result.Funcoes.Add(vFuncao);
            end;
            vNoAux := vNoAux.NextSibling;
          end;
        end

        else if UpperCase(vNo.NodeName)='EQUATING' then
        begin
          vNoAux := vNo.ChildNodes.First;
          while vNoAux <> Nil do
          begin
            vNomeNo := UpperCase(vNoAux.NodeName);

            if vNomeNo='PROGRAM' then
              Result.Equalizacao.Programa := vNoAux.Text
            else if vNomeNo='INPUT' then
              Result.Equalizacao.Input    := vNoAux.Text
            else if vNomeNo = 'OUTPUT' then
            begin
              vFuncao := TFuncao.Create;
              vFuncao.Tipo := tf_Individuo;
              vFuncao.Nome := vNoAux.ChildNodes['name'].Text;
              vFuncao.Programa := vNoAux.ChildNodes['program'].Text;
              Result.Funcoes.Add(vFuncao);
            end;
            vNoAux := vNoAux.NextSibling;
          end;
        end


        else if UpperCase(vNo.NodeName)='OUTPUT' then
        begin
          vNoAux := vNo.ChildNodes.First;

          vFuncao := TFuncao.Create;
          vFuncao.Tipo := tf_Nenhum;
          vFuncao.Nome := vNoAux.Text;
          vNoAux := vNoAux.NextSibling;
          vFuncao.Programa := vNoAux.Text;

          Result.Funcoes.Add(vFuncao);
        end;

        vNo := vNo.NextSibling;
      end;             

      vNo := nil;
    finally
      vXML.Free;
      // vXML := Nil;
      // coUnInitialize;
      // vXML := Nil; //Free;
      // vXML := Nil; //  isso mesmo...
    end;
  end;


var
  vArquivos : TPsqArquivos;
  vArquivo  : TArquivo;
  vIdx : Integer;
  vMetodo   : TMetodo;
  vAtributos : TAtributos;
begin
  CreateDir(PathMetodos+'Temp\');

  vArquivos := TPsqArquivos.Create;
  try

    vArquivos.Pesquisar(PathMetodos+'*.zip',vAtributos);
    vIdx := 0;
    while vArquivos.GetArquivo(vIdx, vArquivo) do
    begin
      Add(Extrai_Dados_Metodo(vArquivo));

      Inc(vIdx);
    end;
  finally
    vArquivos.Free;
  end;
end;


{ TParamsItem }

function TParamsItem.GetParam(pIdx: Integer): TParamItem;
var
  vParam : TParamItem;
begin
  Result := Nil;

  First;
  while (Result=Nil) and (not EOF) do
  begin
    Read(vParam);
    Dec(pIdx);
    if pIdx = 0 then
      Result := vParam
    else
      Next;
  end;
end;

procedure TParamsItem.Read(var pParam: TParamItem);
begin
  inherited GetObject(TObject(pParam));
end;

initialization
vMetodos := TMetodos.Create;
// vMetodos.Carrega;

finalization
vMetodos.Free;


end.
