unit uProcessaTela;

interface

uses
  Forms, Classes, SysUtils, XMLDoc, XMLIntf, StdCtrls, ExtCtrls, Controls, uGeral;

type
  TTipo = (ttc_Edit);

  TElemento = class
    Tipo : TTipo;
    Rotulo : String;
    Nome : String;
    Valor : String;

    Edit : TComponent;
  end;

  TModulo = class(TComposicao)
    Arquivo : TStringList;
    Script : String;
    NomeArquivo : String;
    constructor Create;
    procedure Carrega_Elementos;
    function CriaInterface:TComponent;
    function GetElemento(pIdx:Integer; var pElemento:TElemento):Boolean;
    procedure AtualizaValores;
    destructor Destroy;
  end;

implementation


constructor TModulo.Create;
begin
  inherited;
  Arquivo := TStringList.Create;
end;


procedure TModulo.Carrega_Elementos;


  procedure Busca_Atributos(pNo:IXMLNode; pElemento:TElemento);
  begin
    pElemento.Nome := pNo.ChildNodes['name'].Text;
    pElemento.Rotulo := pNo.ChildNodes['label'].Text;
    pElemento.Valor := pNo.ChildNodes['default'].Text;
  end;


var
  vIdx : Integer;
  vXML : TXMLDocument;
  NodeVariavel : IXMLNode;
  vStream : TMemoryStream;
  NoPrincipal : IXMLNode;
  NoVariavel  : IXMLNode;
  vElemento   : TElemento;
begin
  vXML := TXMLDocument.Create(Application);
  try
    Arquivo.LoadFromFile(NomeArquivo);
    Arquivo.Text := '<?xml version="1.0" encoding="ISO-8859-1" ?>' +
                    '<start>' + Arquivo.Text + '</start>';

    vStream := TMemoryStream.Create;
    try
      Arquivo.SaveToStream(vStream);
      vXML.LoadFromStream(vStream);
    finally
      vStream.Free;
    end;

    // NoPrincipal := vXML.DocumentElement.ChildNodes.FindNode('start');
    NoVariavel := vXML.DocumentElement.ChildNodes.First;
    // NoVariavel := NoPrincipal.childNodes.First;
    while NoVariavel <> Nil do
    begin
      vElemento := TElemento.Create;
      Busca_Atributos(NoVariavel,vElemento);
      Add(vElemento);

      NoVariavel := noVariavel.NextSibling;
    end;

  finally
    vXML.Free// := Nil;
  end;
end;


function TModulo.GetElemento(pIdx:Integer; var pElemento:TElemento):Boolean;
begin
  GetItem(pIdx, Result, TObject(pElemento));
end;


procedure TModulo.AtualizaValores;
var
  vIdx : Integer;
  vElemento : TElemento;
begin
  vIdx := 0;
  while GetElemento(vIdx,vElemento) do
  begin
    vElemento.Valor := TEdit(vElemento.Edit).Text;
    Inc(vIdx);
  end;
end;


function TModulo.CriaInterface:TComponent;
const
  Altura = 50;
var
  vForm : TForm;
  vScroll : TScrollBox;


  function AdicionaElemento(pIdx:Integer; pElemento:TElemento):Integer;
  // Retorna bottom...
  var
    vPainel : TPanel;
    vLabel  : TLabel;
    vEdit   : TEdit;
  begin
    vPainel := TPanel.Create(vForm);
    vPainel.Parent := vScroll;
    vPainel.Top := pIdx * Altura;
    vPainel.Left := 0;
    vPainel.Width := 300;
    vPainel.Height := Altura;
    vPainel.BevelOuter := bvNone;
    vLabel := TLabel.Create(vForm);
    vLabel.Parent := vPainel;
    vLabel.Top := 5;
    vLabel.Left := 5;
    vLabel.Caption := pElemento.Rotulo;
    vEdit := TEdit.Create(vForm);
    vEdit.Parent := vPainel;
    vEdit.Top := 20;
    vEdit.Left := 5;
    vEdit.Text := pElemento.valor;
    pElemento.Edit := vEdit;
    Result := vPainel.Top + vPainel.Height; 
  end;


  procedure Inclui_Botoes(pBottom:Integer);
  var
    vBtnOK : TButton;
    vBtnCancelar : TButton;
  begin
{    vBtnOK := TButton.Create(Result);
    vBtnOK.Parent := Result;
    vBtnOK.Top := pBottom + 5;
    vBtnOK.Caption := 'OK';

    vBtnCancelar := TButton.Create(Result);
    vBtnCancelar.Parent := Result;
    vBtnCancelar.Top := pBottom + 5;
    vBtnCancelar.Caption := 'Cancelar';
    vBtnCancelar.Left := 150; }
  end;


var
  vIdx : Integer;
  vElemento : TElemento;
  vBottom : Integer;
begin
  // Result := TForm.Create(Nil);
  try
    // vForm := Result;
    // vForm.Position := poScreenCenter;

    vScroll := TScrollBox.Create(Nil);
    vScroll.Name := 'ScrollComponentes';
    vScroll.ParentBackground := True;
    vScroll.Parent := vForm;
    vScroll.Align := alClient;
    vScroll.BorderStyle := bsNone;

    Result := vScroll;

    vIdx := 0;
    while GetElemento(vIdx, vElemento) do
    begin
      vBottom := AdicionaElemento(vIdx,vElemento);
      Inc(vIdx);
    end;
    // Inclui_Botoes(vBottom);
    // vForm.Height := vBottom + 75;
    
  except
    // Result.Free;
  end;
end;


destructor TModulo.Destroy;
begin
  Arquivo.Free;
end;


end.
