unit urmConfiguraPlugin;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, uFrmPadrao, ComCtrls, StdCtrls, JvExControls, JvComponent,
  JvEditorCommon, JvEditor, uAcessorios, JvHLEditor, ZipMstr, uDefEstatR;

type
  TFrmConfiguraPlugin = class(TFrmPadrao)
    BtnSalvar: TButton;
    PageControl2: TPageControl;
    TabSheet2: TTabSheet;
    PageControl3: TPageControl;
    TabSheet3: TTabSheet;
    LstArquivos: TListBox;
    BtnCancelar: TButton;
    mmArquivo: TJvHLEditor;
    procedure FormShow(Sender: TObject);
    procedure BtnCancelarClick(Sender: TObject);
    procedure BtnSalvarClick(Sender: TObject);
    procedure LstArquivosClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    vLink : TLink;
    function Pega_Selecionado:String;
  end;

var
  FrmConfiguraPlugin: TFrmConfiguraPlugin;

implementation

{$R *.dfm}

procedure TFrmConfiguraPlugin.FormShow(Sender: TObject);
begin
  inherited;

  LstArquivos.Items.Add(vLink.MainFile);
  LstArquivos.SetFocus;
  LstArquivos.Selected[0] := True;
  LstArquivosClick(Sender);
end;

procedure TFrmConfiguraPlugin.BtnCancelarClick(Sender: TObject);
begin
  inherited;
  Close;
end;

procedure TFrmConfiguraPlugin.BtnSalvarClick(Sender: TObject);
var
  FZip : TZipMaster;
begin
  inherited;

  mmArquivo.Lines.SaveToFile(vLink.TempDir + Pega_Selecionado);

  FZip := TZipMaster.Create(Nil);
  try
    FZip.ZipFileName := cs_DirPlugIns + vLink.PlugInName;
    FZip.FSpecArgs.Append(vLink.TempDir + LstArquivos.Items[0]);
    if FZip.Add <> 0 then
      raise Exception.create('No foi possvel salvar...');
  finally
    FZip.Free;
  end;

  Close;
end;


function TFrmConfiguraPlugin.Pega_Selecionado:String;
var
  vItem : integer;
begin
  Result := '';
  for vItem := 0 to LstArquivos.Items.Count-1 do
  begin
    if LstArquivos.Selected[vItem] then
      Result := LstArquivos.Items[vItem];
  end;
end;


procedure TFrmConfiguraPlugin.LstArquivosClick(Sender: TObject);
var
  vItemSelecionado : String;
begin
  inherited;

  vItemSelecionado := Pega_Selecionado;

  MmArquivo.Lines.Clear;
  if vItemSelecionado <> '' then
    MmArquivo.Lines.LoadFromFile(vLink.TempDir + vItemSelecionado);
end;

end.
